## Newest Release

### 2.2.2 - 15 Mar 2022

- Adds image support to `PSKDFKit.present()` on Android. (#33312)
- Adds a new **Save As** example to the Catalog example project. (#33376)
- Updates for PSPDFKit 11.3.0 for iOS. (#33485)
- Fixes React Native Annotation Processor API for Android. (#33189, #33302)

## Previous Releases

### 2.2.1 - 04 Mar 2022

- Updates for PSPDFKit 8.1.2 for Android. (#33315)
- Updates for PSPDFKit 11.2.4 for iOS. (#33315)
- Fixes React Native Annotation Processor Catalog example for Android.(#33189)

### 2.2.0 - 14 Feb 2022

- This release requires you to update your Android project's `compileSdkVersion` to version 31. Please refer to [our migration guide](https://pspdfkit.com/guides/react-native/migration-guides/react-native-2-2-migration-guide) for this release.
- Adds a `destroyView()` function to `PSPDFKitView` to be used as a workaround for crash caused by a [`react-native-screens` issue](https://github.com/software-mansion/react-native-screens/issues/1300) when navigating back. (#32960)
- Improves the file structure of the Catalog sample project for better readability. (#32685)
- Improves the file structure of the NativeCatalog sample project for better readability. (#32887)
- Updates for PSPDFKit 8.1.1 for Android. (#33017)
- Updates for PSPDFKit 11.2.2 for iOS. (#33017)
- Fixes an issue where the `spreadFitting` configuration value is inverted on Android. (#32789)
- Removes `signingConfig` from React Native Android's sample projects app-level `build.gradle` files. (#32767)

### 2.1.0 - 06 Jan 2022

- Adds documentation for all the configuration options. (#31898)
- Unifies the configuration options on Android and iOS. (#31898)
- PSPDFKit now requires React Native 0.66.4 or later. (#32495)
- PSPDFKit now requires Xcode 13.2.1 or later. (#32495)
- Updates for PSPDFKit 11.2 for iOS. (#32495)
- Fixes an issue where some examples using `Form_example.pdf` would not work. (#32495)

### 2.0.4 - 07 Dec 2021

- Updates the Xcode build settings of the Catalog and Native Catalog example projects to work on iOS simulators on Apple Silicon Macs. (#32129)
- Sets `currentPageIndex` in `onStateChanged` callbacks always to the currently visible page index. Also adds `affectedPageIndex` to get the page that is corresponding to the other states in the callback. (#31926)
- PSPDFKit now requires React Native 0.66.3 or later. (#32119)
- Updates for PSPDFKit 8.0.2 for Android. (#32119)

### 2.0.3 - 02 Nov 2021

- PSPDFKit now requires React Native 0.66.1 or later. (#31744)
- Updates for PSPDFKit 8.0.1 for Android. (#31744)
- Updates for PSPDFKit 11.1 for iOS. (#31654)
- Improves the repository's README. (#31633)

### 2.0.2 - 22 Oct 2021

- Update to PSPDFKit for Android 8.
- PSPDFKit now requires React Native 0.66.0 or later. (#31348)

### 2.0.1 - 05 Oct 2021

- Re-add Java 8 language features. (#31288)

### 2.0.0 - 28 Sep 2021

- Adds the ability to open TIFF images as Image Documents. (#30103)
- Adds a `setLicenseKeys` method which accepts both Android and iOS license keys. (#30943)
- Adds support for iOS 15. (#31008)
- PSPDFKit now requires React Native 0.65.1 or later. (#30947)
- PSPDFKit now requires Xcode 13 or later. (#31008)
- Updates `peerDependencies` and `devDependencies` in `package.json`. (#30947)
- Overhauls the Catalog and NativeCatalog example projects to use the newest version of React Native. (#29342)

### 1.32.2 - 30 Aug 2021

- Migrate from `ReactFragmentActivity` to `ReactActivity` for compatibility with React Native `0.65.1`. (#30771)

### 1.32.1 - 06 Aug 2021

- Adds missing `PSPDFSettingsOption` cases to the configuration for the iOS platform. (#30458)

### 1.32.0 - 23 Jul 2021

- Update for PSPDFKit 7 for Android. (#412)
- Bump minimum SDK version androidMinSdkVersion to API 21. (#412)

### 1.31.6 - 07 Jul 2021

- Fix Android Virtual Device link in the sample projects READMEs.

### 1.31.5 - 07 Jul 2021

- Update for PSPDFKit 10.5 for iOS. (#409)
- Update the minimum deployment target to iOS 13.0. (#409)
- Update the getting started instructions for the Catalog and NativeCatalog example projects. (#409)

### 1.31.4 - 29 Jun 2021

- Make sure page index is set when showing PDF. (#408)

### 1.31.3 - 22 Jun 2021

- Add new “How to Open a PDF in React Native Using the Document Picker" blog post in the “Announcements” section. (#407)

### 1.31.2 - 21 Jun 2021

- Bumped extend from 3.0.1 to 3.0.2 in /samples/Catalog. (#406)
- Bumped lodash from 4.17.15 to 4.17.21 in /samples/NativeCatalog. (#405)

### 1.31.1 - 21 Jun 2021

- Updated the Manual Signing example on iOS to use the new Electronic Signatures API. (#404)
- Bumped glob-parent from 5.1.0 to 5.1.2 in /samples/NativeCatalog. (#404)

### 1.31.0 - 26 May 2021

- Remove the trial license key requirement. (#403)
- Update to PSPDFKit for Android version 6.6.2. (#403)
- Update the README to clarify the Requirements section. (#403)
- Update the README to simplify the Getting Started section. (#403)

### 1.30.18 - 19 May 2021

- Adds a README file for the Catalog example project. (#402)
- Updates the ConfiguredPDFViewComponent iOS example to show the settings button in navigation bar. (#402)
- Fixes issue where the pageIndex prop needed to be set before the document prop. (#402)

### 1.30.17 - 13 May 2021

- Bumped hosted-git-info from 2.8.5 to 2.8.9 in /samples/NativeCatalog. (#401)

### 1.30.16 - 10 May 2021

- Bumped handlebars from 4.7.6 to 4.7.7 in /samples/Catalog. (#398)
- Bumped lodash from 4.17.19 to 4.17.21 in /samples/Catalog. (#399)
- Bumped hosted-git-info from 2.6.0 to 2.8.9 in /samples/Catalog. (#400)

### 1.30.15 - 07 May 2021

- Bumped acorn from 5.7.3 to 5.7.4 in /samples/NativeCatalog. (#397)

### 1.30.14 - 07 May 2021

- Bumped ini from 1.3.5 to 1.3.8 in /samples/NativeCatalog. (#394)
- Bumped handlebars from 4.5.1 to 4.7.7 in /samples/NativeCatalog. (#395)

### 1.30.12 - 07 May 2021

- Workaround a compile issue with Xcode 12.5 in the Catalog and NativeCatalog example projects. (#393)
- Bumped ua-parser-js from 0.7.18 to 0.7.28 in /samples/Catalog. (#393)

### 1.30.11 - 31 Mar 2021

- Fixed “TypeError: cb.apply is not a function” when running the Catalog example project. (#392)
- Bumped y18n from 3.2.1 to 3.2.2 in /samples/Catalog. (#392)

### 1.30.10 - 09 Mar 2021

- Exposes the Reader View button on iOS. (#391)

### 1.30.9 - 03 Mar 2021

- Updates the Getting Started instructions for Android and iOS. (#390)

### 1.30.8 - 11 Feb 2021

- Update to PSPDFKit for Android version 6.6.0.

### 1.30.7 - 09 Feb 2021

- Fixes issue where disableAutomaticSaving did not work on iOS when useParentNavigationBar was enabled. (#389)

### 1.30.6 - 02 Feb 2021

- Update for PSPDFKit 10.2 for iOS, Xcode 12.4 and React Native 0.63.4. (#387)
- Update LICENSE to 2021.

### 1.30.5 - 11 Jan 2021

- Updated installation steps for the iOS Catalog app. (Z-22173)
- Update copyright year to 2021. (#386)
- Fixed annotation tapped events not being emitted when editing is disabled on Android. (#385)
- Fixed stamps not being correctly detected. (#384)

### 1.30.4 - 15 Dec 2020

- Bump ini from 1.3.5 to 1.3.7 in /samples/Catalog. (#383)

### 1.30.3 - 16 Nov 2020

- Update for PSPDFKit 10.1 for iOS and Xcode 12.2. (#382)

### 1.30.2 - 30 Oct 2020

- Update to PSPDFKit 6.5.3 for Android. (#380)

### 1.30.1 - 13 Oct 2020

- Update to PSPDFKit for Android 6.5.2.
- Update to PSPDFKit for iOS 10.0.1.

### 1.30.0 - 22 Sep 2020

- Update for PSPDFKit 10 for iOS, iOS 14, and Xcode 12. (#378)

### 1.29.10 - 14 Sep 2020

- Fixes an issue on iOS where the last page view would be layed out incorrectly in single page mode and scroll per spread page trasition after device rotation. (#377)

### 1.29.9 - 08 Sep 2020

- Update Getting started instructions for React Native 0.63.2. (#376)
- Bump lodash from 4.17.10 to 4.17.19 in /samples/Catalog. (#374)

### 1.29.8 - 13 Aug 2020

- Fixes an issue that prevented you from adding images from the gallery or camera on Android when using the PSPDFKitView. (#375)

### 1.29.7 - 15 Jul 2020

- Update to PSPDFKit 6.5 for Android. (#373)

### 1.29.6 - 14 Jul 2020

- Update for PSPDFKit 9.5 for iOS. (#371)

### 1.29.5 - 07 Jul 2020

- Fixes an issue that prevented PSPDFKitView from loading. (#372).

### 1.29.4 - 18 Jun 2020

- Update for PSPDFKit 6.4 for Android. (#370)

### 1.29.3 - 17 Jun 2020

- Update for PSPDFKit 9.4 for iOS. (#369)

### 1.29.2 - 25 May 2020

- Adds Javascript API on to customize the font picker on Android and iOS. (#363)
- Updated the Catalog sample project dependencies. (#368)

### 1.29.1 - 27 Apr 2020

- Adds enableFormEditing to configuration. (#365)

### 1.29.0 - 24 Apr 2020

- Updates PSPDFKit for Android to 6.3. (#364)
- Resolves #352.
- Resolves #359.

### 1.28.7 - 15 Apr 2020

- Bridges the Instant Example from the iOS PSPDFKit Catalog to the NativeCatalog React Native project. (#362)

### 1.28.6 - 26 Mar 2020

- Add support for hiding the main toolbar on Android. (#360)

### 1.28.5 - 25 Mar 2020

- Fixes warning in the Xcode project by migrating the development region. (#361)

### 1.28.4 - 18 Mar 2020

- Adds Native Catalog sample project with advanced integration examples on iOS. (#339)

### 1.28.3 - 16 Mar 2020

- Reload the entire PSPDFViewController instead of only reloading the currently visible page when adding adding annotations via the addAnnotations API. (#357)

### 1.28.2 - 16 Mar 2020

- Updates to PSPDFKit for Android 6.2.0. (#353)

### 1.28.1 - 10 Mar 2020

- Put PSPDFKit on Gradle's api configuration making PSPDFKit classes available on an app's Java class path. (#355)

### 1.28.0 - 06 Mar 2020

- Add bookmark action configuration option. (#354)

### 1.27.5 - 19 Feb 2020

- Update README to mention the newly added annotation processing API. (#351)

### 1.27.4 - 19 Feb 2020

- Adds new API for annotation processing on Android and iOS. (#350)

### 1.27.3 - 12 Feb 2020

- Fix two navigation buttons being shown while the search is open. (#347)
- Return a promise when calling PSPDFKit.present(). (#348)
- Include uuid in annotation removed event. (#349)
- Return a promise when calling PSPDFKit.present(). (#348)
- Include creator name in annotation removed event. (#349)

### 1.27.2 - 04 Feb 2020

- Adds new toolbarTitle, and showSettingsMenu configuration options. (#345)
- Adds new showNavigationButtonInToolbar, and onNavigationButtonClicked props to PSPDFKitView. (#345)

### 1.27.1 - 03 Feb 2020

- Add new “How to Bridge Native iOS Code to React Native” blog post and video tutorial in the “Announcements” section. (#346)

### 1.27.0 - 30 Jan 2020

- The Android PdfView now internally uses the PdfUiFragment meaning it provides the same UI as the PdfActivity. #322

### 1.26.8 - 28 Jan 2020

- Adds instructions for how to use the Experimental Mac Catalyst Support. (#343)

### 1.26.7 - 21 Jan 2020

- Bumps PSPDFKit for Android version to 6.1.1. (#342)

### 1.26.6 - 10 Jan 2020

- Bumps PSPDFKit for Android version to 6.1. (#337)

### 1.26.5 - 13 Dec 2019

- Adds new Watermarking Example to Native Catalog. (#325)

### 1.26.4 - 05 Nov 2019

- Adds a new Native Catalog example for Android showing how to use the PdfView in your own bridge code. (#318)
- Adds PdfView#getFragment() method to make retrieving the current fragment easier.
- Adds PdfView#createDefaultEventRegistrationMap() method to make writing custom view manager easier.

### 1.26.3 - 28 Oct 2019

- Updates the PSPDFKit for Android version to 6.0.2. (#312)
- Add support for enableAnnotationEditing and editableAnnotationTypes prop to Android. (#311)
- Make saveCurrentDocument and setFormFieldValue return a promise on Android and iOS. (#308)

### 1.26.2 - 16 Oct 2019

- Adds the annotation name to the onAnnotationsChanged payload when annotation is removed on iOS. (#309)
- Fixes enableAnnotationEditing on iOS. (#310)

### 1.26.1 - 09 Oct 2019

- Force UIModalPresentationFullScreen for the native module on iOS 13. (#307)

### 1.26.0 - 23 Sep 2019

- Update for PSPDFKit 9 for iOS.

### 1.25.8 - 09 Sep 2019

- Add setLicenseKey method to Android. (#290)
- Add disableAutomaticSaving configuration to Android. (#289)

### 1.25.7 - 31 Aug 2019

- Added a comment to explain why we dismiss he PSPDFViewController in -[RCTPSPDFKitView removeFromSuperview]. (#287)

### 1.25.6 - 28 Aug 2019

- Fixed a crash that would occur when adding an invalid Instant JSON payload. (#284)

### 1.25.5 - 28 Aug 2019

- Dismiss the PDF view controller when the view component is unmounted to avoid orphan popovers. (#280)

### 1.25.4 - 14 Aug 2019

- Fixes reloading causing the PdfView to get into a state where it never loads. (#269)

### 1.25.3 - 13 Aug 2019

- Update the integration steps now that linking is automatic via CocoaPods. (#265)

### 1.25.2 - 09 Aug 2019

- Fixes issue with trial maven keys. (#266)
- Updates PSPDFKit for Android from 5.5.0 to 5.5.1.

### 1.25.1 - 08 Aug 2019

- Adds getAllAnnotations() JavaScript API to query all annotation from a document. (#167)

### 1.25.0 - 06 Aug 2019

- This release bumps the required react-native version to 0.60.4. (#263)
- The PSPDFKit version on Android was updated to 5.5.0.
- We now require AndroidX, make sure to look at the official release blog for more information on the migration.

### 1.24.9 - 25 Jul 2019

- Annotation modification methods now return a promise on Android (#251, #250)
- Changing the configuration prop now updates the PdfFragment on Android (#252)

### 1.24.8 - 25 Jul 2019

- Improves error handling for annotation manipulations functions on iOS. (#261)

### 1.24.7 - 18 Jul 2019

- React Native 0.60.x uses CocoaPods by default, so we've updated the iOS integration steps. See https://github.com/PSPDFKit/react-native#ios for more details. (#257)

### 1.24.6 - 16 Jul 2019

- Adds toolbarTitle Javascript API to override the iOS toolbar title. (#255)
- Updated the README to add a section about how to Customize the Toolbar Buttons. (#256)

### 1.24.5 - 15 Jul 2019

- Fixes memory leak issue in react native windows with newtonsoft.

### 1.24.4 - 11 Jul 2019

- Restores support for react-native 0.57 on Android.
- Adds onDocumentLoadFailed callback on iOS / Android
- Improves document path resolution on Android.

### 1.24.3 - 01 Jul 2019

- Bump version to 1.24.3 (#242)

### 1.24.2 - 19 Jun 2019

- Improves the CocoaPods integration. (#235)

### 1.24.1 - 14 Jun 2019

- Update the Android and iOS Catalog apps for React Native 0.59.9. (#193)

### 1.24.0 - 12 Jun 2019

- Adds Javascript API to customize the toolbar on iOS. (#233)

### 1.23.16 - 28 May 2019

- Merge pull request #232 from PSPDFKit/rad/fix-broken-link.
- Fix broken link in the README.

### 1.23.15 - 28 May 2019

- Merge pull request #227 from PSPDFKit/reinhard/add-page-mode-config.
- Fix for double page mode configuration missing on Android.

### 1.23.14 - 28 May 2019

- Create the PDFViewPage when asked to by react native. (#229)
- There was a lifetime issue when navigating back and forth between views. Now we create a view when react native wants to. The unloading is still handled in UWP.

### 1.23.13 - 22 May 2019

- Update wrapper to PSPDFKit for Windows 2.0 (#223)
- Update references
- Make JsonUtils compatible.
- update all nuget versions.
- removed alert from library search example as this is more than fast enough now.

### 1.23.12 - 22 May 2019

- Align annotations changed with ios (#224)
- This PR changes annotation events on UWP to pass back a list of annotations like Android and iOS does.

### 1.23.11 - 21 May 2019

- UWP: Remove Annotation (#222)
- Brings UWP removeAnnotation API inline with iOS and Android.
- Also fixes small typo with getAnnotations JSON reply.

### 1.23.10 - 07 May 2019

- Re-implement Css Customization (#221)
- As explained in #219 (comment) due to limitations with file permissions in UWP it was necessary to rework the CSS customization. Therefore now the viable solution is to provide a native option.
- In this PR I have reverted the previous CSS work and added the option to start the PSPDFKit react native package with a Uri parameter which will be passed as the CSS resource. Within this CSS resource, it's possible to set the main colors of the toolbar. As before.

### 1.23.9 - 30 Apr 2019

- Fix crash when null colors are passed (#218)
- JObject throws when checking for a null or undefined value. Instead of throwing we check for this and do not include the value allow the application to continue.

### 1.23.8 - 24 Apr 2019

- Merge pull request #210 from PSPDFKit/rad/update-for-PSPDFKit-8.3-ios.
- Update for PSPDFKit 8.3 for iOS.

### 1.23.7 - 17 Apr 2019

- Updated and tested 1.12. (#211)
- A simple update to PSPDFKit for Windows 1.12.
- All tested fine.

### 1.23.6 - 15 Apr 2019

- Merge pull request #209 from PSPDFKit/rad/document-validation-check
- Check if document is valid before adding or removing annotations

### 1.23.5 - 08 Apr 2019

- Fix set toolbar promise. (#208)
- Mistakenly did not handle the promise for set toolbar and therefore it was never fired. Same is true for the error.

### 1.23.4 - 02 Apr 2019

- Merge pull request #202 from PSPDFKit/github-templates.
- Add Github issue and pull request templates.

### 1.23.3 - 01 Apr 2019

- Merge pull request #201 from PSPDFKit/release-1.23.3.

### 1.23.2 - 22 Mar 2019

- Merge pull request #192 from PSPDFKit/release-1.23.2.

### 1.23.1 - 19 Mar 2019

- UWP: Update to PSPDFKit for Windows 1.11.0. (#186)

### 1.23.0 - 15 Jan 2019

- Update for PSPDFKit 8.1.3 for iOS.

### 1.22.0 - 15 Nov 2018

- Update PSPDFKit to 5.0.1 for Android (#141)

### 1.21.1 - 25 Oct 2018

- Remove invalid setting option on iOS. (8603e34)

### 1.21.0 - 17 Oct 2018

- Update for PSPDFKit 8 for iOS. (#131)

### 1.20.0 - 28 Aug 2018

- Adds the ability to programmatically toggle the annotation toolbar. (#105, #108)
- Adds Programmatic PDF form filling. (#106, #107)
- Adds Event Listeners Catalog example.
- Adds API and Catalog example to manually save a document.
- Add catalog example for changing pages. (#98)
- Adds getAnnotations to get all annotations of a page.
- Adds addAnnotation to add a single annotation using Instant JSON.
- Adds getAllUnsavedAnnotations to export the document Instant JSON.
- Adds addAnnotations to parse the document Instant JSON.
- Adds disableAutomaticSaving prop to disable automatic saving when exiting the document.
- Adds annotationAuthorName prop to set the annotation author used when creating annotations.
- Adds callbacks for when an annotation is added, changed or deleted.
